# require 'url_parser'

module DoList
  class AuthToken
    def initialize(params = {})
      @headers = params[:headers]
      @account_id = params[:account_id]
      @api_key = params[:api_key]
      @uri = DoList::UrlParser.parse_url(params[:url])
      @http = DoList::UrlParser.request_http(@uri)
      @auth_key, @auth_depr_date = request_auth_key
    end

    def auth_key
      @auth_key, @auth_depr_date = request_auth_key if (DateTime.now + (1 / 24.0)) > @auth_depr_date
      @auth_key
    end

    private

    def request_auth_key
      document = DoList::UrlParser.post_http(@http, @uri, body, @headers)
      parsed = []
      parsed << document.xpath('//Key').children.to_s
      parsed << DateTime.parse(document.xpath('//DeprecatedDate').children.to_s)
    end

    def body
      <<-GETAUTHBODY
        <soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:v2="http://api.dolist.net/v2">
          <soapenv:Header/>
          <soapenv:Body>
             <v2:GetAuthenticationToken>
                <v2:authenticationRequest>
                   <v2:AccountID>#{@account_id}</v2:AccountID>
                   <v2:AuthenticationKey>#{@api_key}</v2:AuthenticationKey>
                </v2:authenticationRequest>
             </v2:GetAuthenticationToken>
          </soapenv:Body>
        </soapenv:Envelope>
      GETAUTHBODY
    end
  end
end
